﻿using System;
using System.Configuration;
using System.Security.Cryptography;
using System.Text;
using Org.BouncyCastle.Crypto.Parameters;
using Org.BouncyCastle.Math;

namespace auth_data_generate
{
    public class SecureDecryptorDotNet
    {
        static RSACryptoServiceProvider _rsa;
        static string _base64Encrypted;
        private const string ModulusInit = "21wEnTU+mcD2w0Lfo1Gv4rtcSWsQJQTNa6gio05AOkV/Er9w3Y13Ddo5wGtjJ19402S71HUeN0vbKILLJdRSES5MHSdJPSVrOqdrll/vLXxDxWs/U0UT1c8u6k/Ogx9hTtZxYwoeYqdhDblof3E75d9n2F0Zvf6iTb4cI7j6fMs=";
        private const string PublicExponentInit = "AQAB";

        private static RsaKeyParameters _rsaPublicParam;

        private static string _getModulus, _getPublicExponent, _getP, _getD, _getQ, _getInverseQ, _getPD, _getQd;

        public static void Init()
        {
            _getModulus = ConfigurationManager.AppSettings["modulus"] ?? ModulusInit;
            _getPublicExponent = ConfigurationManager.AppSettings["publicExponent"] ?? PublicExponentInit;

            _getP = ConfigurationManager.AppSettings["P"] ?? PublicExponentInit;
            _getD = ConfigurationManager.AppSettings["D"] ?? PublicExponentInit;
            _getQ = ConfigurationManager.AppSettings["Q"] ?? PublicExponentInit;
            _getInverseQ = ConfigurationManager.AppSettings["InverseQ"] ?? PublicExponentInit;
            _getPD = ConfigurationManager.AppSettings["DP"] ?? PublicExponentInit;
            _getQd = ConfigurationManager.AppSettings["DQ"] ?? PublicExponentInit;

        }

        public static string RSAEncryptOrDecrypt(string data, bool encrypt = true)
        {
            Init();

            var dataEncoded = Encoding.UTF8.GetBytes(data);
            Console.WriteLine("Data Encoded to Bytes{0}", dataEncoded);

            if (encrypt)
            {
                using (_rsa = new RSACryptoServiceProvider())
                {
                    try
                    {

                        var n = new BigInteger(_getModulus, 16);
                        var e = new BigInteger(_getPublicExponent, 16);

                        _rsaPublicParam = new RsaKeyParameters(false, n, e);

                        var rsaParameters = new RSAParameters();

                        rsaParameters.Modulus = _rsaPublicParam.Modulus.ToByteArrayUnsigned();
                        rsaParameters.Exponent = _rsaPublicParam.Exponent.ToByteArrayUnsigned();

                        _rsa.ImportParameters(rsaParameters);

                        var encryptedData = _rsa.Encrypt(dataEncoded, false);

                        _base64Encrypted = Convert.ToBase64String(encryptedData);

                    }
                    catch (Exception exception)
                    {
                        _base64Encrypted = "Unable to encrypt:" + exception;
                    }

                }
                return _base64Encrypted;
            }

            try
            {
                var n = new BigInteger(_getModulus, 16);
                var e = new BigInteger(_getPublicExponent, 16);

                _rsaPublicParam = new RsaKeyParameters(false, n, e);

                var rsaParameters = new RSAParameters();

                rsaParameters.Modulus = _rsaPublicParam.Modulus.ToByteArrayUnsigned();
                rsaParameters.Exponent = _rsaPublicParam.Exponent.ToByteArrayUnsigned();

                _rsa.ImportParameters(rsaParameters);

                var resultBytes = Convert.FromBase64String(_base64Encrypted);
                var decryptedBytes = _rsa.Decrypt(resultBytes, true);

                return Encoding.UTF8.GetString(decryptedBytes);
            }
            catch (Exception exception)
            {
                _base64Encrypted = "Unable to decypt:" + exception;
            }
            return _base64Encrypted;

        }
    }
}
